## libsolv 0.6.21

=== CMakeLists.txt ===
PROJECT (libsolv)

CMAKE_MINIMUM_REQUIRED (VERSION 2.4)

OPTION (ENABLE_STATIC "Build a static version of the libraries?" OFF)
OPTION (DISABLE_SHARED "Do not build a shared version of the libraries?" OFF)

OPTION (ENABLE_PERL "Build the perl bindings?" OFF)
OPTION (ENABLE_PYTHON "Build the python bindings?" OFF)
OPTION (ENABLE_RUBY "Build the ruby bindings?" OFF)
OPTION (ENABLE_TCL "Build the Tcl bindings?" OFF)

OPTION (USE_VENDORDIRS "Install the bindings in vendor directories?" OFF)

OPTION (ENABLE_RPMDB "Build with rpm database support?" OFF)
OPTION (ENABLE_PUBKEY "Build with pubkey support?" OFF)
OPTION (ENABLE_RPMDB_BYRPMHEADER "Build with rpmdb Header support?" OFF)
OPTION (ENABLE_RPMMD "Build with rpmmd repository support?" OFF)
OPTION (ENABLE_SUSEREPO "Build with suse repository support?" OFF)
OPTION (ENABLE_COMPS "Build with fedora comps support?" OFF)
OPTION (ENABLE_HELIXREPO "Build with helix repository support?" OFF)
OPTION (ENABLE_DEBIAN "Build with debian database/repository support?" OFF)
OPTION (ENABLE_MDKREPO "Build with mandriva/mageia repository support?" OFF)
OPTION (ENABLE_ARCHREPO "Build with archlinux repository support?" OFF)
OPTION (ENABLE_CUDFREPO "Build with cudf repository support?" OFF)
OPTION (ENABLE_HAIKU "Build with Haiku package support?" OFF)
OPTION (ENABLE_APPDATA "Build with AppStream appdata support?" OFF)

OPTION (MULTI_SEMANTICS "Build with support for multiple distribution types?" OFF)

OPTION (ENABLE_LZMA_COMPRESSION "Build with lzma/xz compression support?" OFF)
OPTION (ENABLE_BZIP2_COMPRESSION "Build with bzip2 compression support?" OFF)

#IF(${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERISION} GREATER 2.4)
#ENDIF(${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERISION} GREATER 2.4)

IF (COMMAND cmake_policy)
  # escape preprocessor, see -DVERSION below
  CMAKE_POLICY (SET CMP0005 OLD)
ENDIF (COMMAND cmake_policy)

# Library
IF (DEFINED LIB)
  SET (LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/${LIB}")
ELSE (DEFINED  LIB)
  IF (CMAKE_SIZEOF_VOID_P MATCHES "8")
    SET (LIB_SUFFIX "64")
  ENDIF (CMAKE_SIZEOF_VOID_P MATCHES "8")
  SET (LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
ENDIF (DEFINED  LIB)
MESSAGE (STATUS "Libraries will be installed in ${LIB_INSTALL_DIR}")
# Library
IF (DEFINED INCLUDE)
  SET (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/${INCLUDE}")
else (DEFINED INCLUDE)
  SET (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include")
ENDIF (DEFINED  INCLUDE)
MESSAGE (STATUS "Header files will be installed in ${INCLUDE_INSTALL_DIR}")
SET (BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin")
SET (MAN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/man")
IF (IS_DIRECTORY "${CMAKE_INSTALL_PREFIX}/man"  AND NOT IS_DIRECTORY "${CMAKE_INSTALL_PREFIX}/share/man")
  SET (MAN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/man")
ENDIF (IS_DIRECTORY "${CMAKE_INSTALL_PREFIX}/man"  AND NOT IS_DIRECTORY "${CMAKE_INSTALL_PREFIX}/share/man")
MESSAGE(STATUS "Man pages will be installed in ${MAN_INSTALL_DIR}")

####################################################################
# CONFIGURATION                                                    #
####################################################################

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
SET (CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
INSTALL( FILES ${CMAKE_MODULE_PATH}/FindLibSolv.cmake DESTINATION ${CMAKE_INSTALL_PREFIX}/share/cmake/Modules )

INCLUDE (${CMAKE_SOURCE_DIR}/VERSION.cmake)

SET (have_system x)

IF (FEDORA)
MESSAGE(STATUS "Building for Fedora")
ADD_DEFINITIONS (-DFEDORA)
SET (ENABLE_RPMDB ON)
SET (ENABLE_RPMMD ON)
SET (have_system ${have_system}x)
ENDIF (FEDORA)

IF (DEBIAN)
MESSAGE (STATUS "Building for Debian")
ADD_DEFINITIONS (-DDEBIAN)
SET (ENABLE_DEBIAN ON)
SET (have_system ${have_system}x)
ENDIF (DEBIAN)

IF (SUSE)
MESSAGE (STATUS "Building for SUSE")
ADD_DEFINITIONS (-DSUSE)
SET (ENABLE_RPMDB ON)
SET (ENABLE_PUBKEY ON)
SET (ENABLE_RPMDB_BYRPMHEADER ON)
SET (ENABLE_RPMMD ON)
SET (ENABLE_SUSEREPO ON)
SET (ENABLE_HELIXREPO ON)
SET (ENABLE_LINKED_PKGS ON)
SET (have_system ${have_system}x)
ENDIF (SUSE)

IF (ARCHLINUX)
MESSAGE (STATUS "Building for Archlinux")
ADD_DEFINITIONS (-DARCHLINUX)
SET (ENABLE_ARCHREPO ON)
SET (have_system ${have_system}x)
ENDIF (ARCHLINUX)

IF (MANDRIVA)
MESSAGE (STATUS "Building for Mandriva")
ADD_DEFINITIONS (-DMANDRIVA)
SET (ENABLE_MDKREPO ON)
SET (ENABLE_RPMDB ON)
SET (have_system ${have_system}x)
ENDIF (MANDRIVA)

IF (MAGEIA)
MESSAGE (STATUS "Building for Mageia")
ADD_DEFINITIONS (-DMAGEIA)
SET (ENABLE_MDKREPO ON)
SET (ENABLE_RPMDB ON)
SET (ENABLE_RPMMD ON)
SET (ENABLE_LZMA_COMPRESSION ON)
SET (have_system ${have_system}x)
ENDIF (MAGEIA)

IF (HAIKU)
MESSAGE(STATUS "Building for Haiku")
FIND_LIBRARY(HAIKU_BE_LIBRARY NAMES be)
FIND_LIBRARY(HAIKU_NETWORK_LIBRARY NAMES network)
FIND_LIBRARY(HAIKU_PACKAGE_LIBRARY NAMES package)
SET (HAIKU_SYSTEM_LIBRARIES
    ${HAIKU_BE_LIBRARY} ${HAIKU_NETWORK_LIBRARY} ${HAIKU_PACKAGE_LIBRARY})
ADD_DEFINITIONS (-DHAIKU)
SET (ENABLE_HAIKU ON)
SET (have_system ${have_system}x)
ENDIF (HAIKU)

IF (${have_system} STREQUAL x)
    MESSAGE (STATUS "Building for no system")
ENDIF (${have_system} STREQUAL x)
IF (${have_system} STRGREATER xx)
    MESSAGE (FATAL_ERROR "Can only compile for one system type.")
ENDIF (${have_system} STRGREATER xx)

IF (ENABLE_ARCHREPO)
SET (ENABLE_LZMA_COMPRESSION ON)
ENDIF (ENABLE_ARCHREPO)

FIND_PACKAGE (EXPAT REQUIRED)
FIND_PACKAGE (ZLIB REQUIRED)
IF (ENABLE_LZMA_COMPRESSION)
FIND_PACKAGE (LZMA REQUIRED)
ENDIF (ENABLE_LZMA_COMPRESSION)
IF (ENABLE_BZIP2_COMPRESSION)
FIND_PACKAGE (BZip2 REQUIRED)
ENDIF (ENABLE_BZIP2_COMPRESSION)

IF (RPM5)
MESSAGE (STATUS "Enabling RPM 5 support")
ADD_DEFINITIONS (-DRPM5)
SET (ENABLE_RPMDB ON)
SET (ENABLE_RPMMD ON)
FIND_PACKAGE (PkgConfig REQUIRED)
PKG_CHECK_MODULES (RPM REQUIRED rpm)
INCLUDE_DIRECTORIES (${RPM_INCLUDE_DIRS})
ENDIF (RPM5)

IF (MULTI_SEMANTICS)
MESSAGE (STATUS "Enabling multi dist support")
ADD_DEFINITIONS (-DMULTI_SEMANTICS)
ENDIF (MULTI_SEMANTICS)

INCLUDE (CheckIncludeFile)
IF (ENABLE_RPMDB)
  FIND_LIBRARY (RPMDB_LIBRARY NAMES rpmdb)

  IF (NOT RPMDB_LIBRARY)
    FIND_LIBRARY (RPMDB_LIBRARY NAMES rpm)
  ENDIF (NOT RPMDB_LIBRARY)

  FIND_LIBRARY (RPMIO_LIBRARY NAMES rpmio)
  IF (RPMIO_LIBRARY)
    SET(RPMDB_LIBRARY ${RPMIO_LIBRARY} ${RPMDB_LIBRARY})
  ENDIF (RPMIO_LIBRARY)

  IF (RPM5)
    FIND_LIBRARY (RPMMISC_LIBRARY NAMES rpmmisc)
    IF (RPMMISC_LIBRARY)
      SET (RPMDB_LIBRARY ${RPMMISC_LIBRARY} ${RPMDB_LIBRARY})
    ENDIF (RPMMISC_LIBRARY)
  ENDIF (RPM5)

  # check if rpm contains a bundled berkeley db
  CHECK_INCLUDE_FILE(rpm/db.h HAVE_RPM_DB_H)
  IF (NOT HAVE_RPM_DB_H)
    FIND_LIBRARY (DB_LIBRARY NAMES db)
    IF (DB_LIBRARY)
      SET (RPMDB_LIBRARY ${DB_LIBRARY} ${RPMDB_LIBRARY})
    ENDIF (DB_LIBRARY)
  ENDIF (NOT HAVE_RPM_DB_H)
  INCLUDE (CheckLibraryExists)
  CHECK_LIBRARY_EXISTS(rpmio pgpDigGetParams "" HAVE_PGPDIGGETPARAMS)
ENDIF (ENABLE_RPMDB)

IF (ENABLE_PUBKEY)
  SET (ENABLE_PGPVRFY ON)
ENDIF (ENABLE_PUBKEY)

INCLUDE (CheckFunctionExists)
INCLUDE (TestBigEndian)

CHECK_FUNCTION_EXISTS (strchrnul HAVE_STRCHRNUL)
CHECK_FUNCTION_EXISTS (fopencookie HAVE_FOPENCOOKIE)
CHECK_FUNCTION_EXISTS (funopen HAVE_FUNOPEN)
TEST_BIG_ENDIAN (WORDS_BIGENDIAN)

IF (${CMAKE_MAJOR_VERSION} GREATER 2)
INCLUDE (CMakePushCheckState)
INCLUDE (CheckCCompilerFlag)
MACRO (check_linker_flag FLAG VAR)
	CMAKE_PUSH_CHECK_STATE (RESET)
	SET (CMAKE_REQUIRED_FLAGS "${FLAG}")
	CHECK_C_COMPILER_FLAG ("" "${VAR}")
	CMAKE_POP_CHECK_STATE ()
ENDMACRO (check_linker_flag)
check_linker_flag("-Wl,--as-needed" HAVE_LINKER_AS_NEEDED)
check_linker_flag("-Wl,--version-script=${CMAKE_SOURCE_DIR}/src/libsolv.ver" HAVE_LINKER_VERSION_SCRIPT)
ELSE (${CMAKE_MAJOR_VERSION} GREATER 2)
SET (HAVE_LINKER_AS_NEEDED 1)
SET (HAVE_LINKER_VERSION_SCRIPT 1)
ENDIF (${CMAKE_MAJOR_VERSION} GREATER 2)

# should create config.h with #cmakedefine instead...
FOREACH (VAR HAVE_STRCHRNUL HAVE_FOPENCOOKIE HAVE_FUNOPEN WORDS_BIGENDIAN
  HAVE_RPM_DB_H HAVE_PGPDIGGETPARAMS
  ENABLE_RPMDB ENABLE_PUBKEY ENABLE_RPMMD ENABLE_RPMDB_BYRPMHEADER ENABLE_SUSEREPO ENABLE_COMPS
  ENABLE_HELIXREPO ENABLE_MDKREPO ENABLE_ARCHREPO ENABLE_DEBIAN ENABLE_HAIKU
  ENABLE_LZMA_COMPRESSION ENABLE_BZIP2_COMPRESSION ENABLE_PGPVRFY ENABLE_APPDATA
  ENABLE_LINKED_PKGS ENABLE_COMPLEX_DEPS)
  IF(${VAR})
    ADD_DEFINITIONS (-D${VAR}=1)
    SET (SWIG_FLAGS ${SWIG_FLAGS} -D${VAR})
  ENDIF (${VAR})
ENDFOREACH (VAR)

SET (PACKAGE "libsolv")
SET (VERSION "${LIBSOLV_MAJOR}.${LIBSOLV_MINOR}.${LIBSOLV_PATCH}")

ADD_DEFINITIONS (-D_FILE_OFFSET_BITS=64)
ADD_DEFINITIONS (-DVERSION=\\\"${VERSION}\\\")
CONFIGURE_FILE (src/solvversion.h.in src/solvversion.h)

SET (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Package dependency solver library")
SET (CPACK_PACKAGE_VENDOR "SUSE")
SET (CPACK_PACKAGE_VERSION_MAJOR ${LIBSOLV_MAJOR})
SET (CPACK_PACKAGE_VERSION_MINOR ${LIBSOLV_MINOR})
SET (CPACK_PACKAGE_VERSION_PATCH ${LIBSOLV_PATCH})
SET (CPACK_GENERATOR "TBZ2")
SET (CPACK_SOURCE_GENERATOR "TBZ2")
SET (CPACK_SOURCE_PACKAGE_FILE_NAME "${PACKAGE}-${VERSION}")
SET (CPACK_SOURCE_TOPLEVEL_TAG "Linux-Source:")
SET (CPACK_TOPLEVEL_TAG "Linux-Source:")

# The following components are regex's to match anywhere (unless anchored)
# in absolute path + filename to find files or directories to be excluded
# from source tarball.
SET (CPACK_SOURCE_IGNORE_FILES
# temporary files
"\\\\.swp$"
# backup files
"~$"
# eclipse files
"\\\\.cdtproject$"
"\\\\.cproject$"
"\\\\.project$"
"\\\\.settings/"
# others
"\\\\.#"
"/#"
"/build/"
"/_build/"
"/\\\\.git/"
# used before
"/\\\\.libs/"
"/\\\\.deps/"
"\\\\.o$"
"\\\\.lo$"
"\\\\.la$"
"Makefile$"
"Makefile\\\\.in$"
# cmake cache files
"DartConfiguration.tcl$"
"CMakeCache.txt"
"CMakeFiles"
"cmake_install.cmake$"
"CMakeLists.txt.auto$"
"CTestTestfile.cmake"
"CPackConfig.cmake$"
"CPackSourceConfig.cmake$"
"libsolv.spec$"
)

INCLUDE(CPack)

####################################################################
# INCLUDES                                                         #
####################################################################

#SET (CMAKE_INCLUDE_DIRECTORIES_BEFORE ON)
INCLUDE_DIRECTORIES (${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/ext ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_BINARY_DIR}/src SYSTEM )

####################################################################

MESSAGE (STATUS "Looking for modules in ${CMAKE_MODULE_PATH}")

set (CMAKE_C_FLAGS     "${CMAKE_C_FLAGS} -Wall")
set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS} -O3")
set (CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS} -g -O3")
set (CMAKE_C_FLAGS_DEBUG     "${CMAKE_C_FLAGS} -g3 -O0")

SET (SYSTEM_LIBRARIES ${EXPAT_LIBRARY} ${ZLIB_LIBRARY})
IF (ENABLE_LZMA_COMPRESSION)
SET (SYSTEM_LIBRARIES ${SYSTEM_LIBRARIES} ${LZMA_LIBRARY})
ENDIF (ENABLE_LZMA_COMPRESSION)
IF (ENABLE_BZIP2_COMPRESSION)
SET (SYSTEM_LIBRARIES ${SYSTEM_LIBRARIES} ${BZIP2_LIBRARIES})
ENDIF (ENABLE_BZIP2_COMPRESSION)
IF (ENABLE_RPMDB)
SET (SYSTEM_LIBRARIES ${RPMDB_LIBRARY} ${SYSTEM_LIBRARIES})
ENDIF (ENABLE_RPMDB)
IF (ENABLE_HAIKU)
SET (SYSTEM_LIBRARIES ${HAIKU_SYSTEM_LIBRARIES} ${SYSTEM_LIBRARIES})
ENDIF (ENABLE_HAIKU)
IF (HAVE_LINKER_AS_NEEDED)
SET (SYSTEM_LIBRARIES "-Wl,--as-needed" ${SYSTEM_LIBRARIES})
ENDIF (HAVE_LINKER_AS_NEEDED)

ADD_SUBDIRECTORY (src)
ADD_SUBDIRECTORY (ext)
ADD_SUBDIRECTORY (tools)
IF (ENABLE_PERL OR ENABLE_PYTHON OR ENABLE_RUBY OR ENABLE_TCL)
    ADD_SUBDIRECTORY (bindings)
ENDIF (ENABLE_PERL OR ENABLE_PYTHON OR ENABLE_RUBY OR ENABLE_TCL)
ADD_SUBDIRECTORY (examples)
ADD_SUBDIRECTORY (doc)

MESSAGE (STATUS "Version: ${VERSION}")

####################################################################
# RPM SPEC                                                         #
####################################################################

MACRO (SPECFILE)
  MESSAGE (STATUS "Writing spec file...")

=== ext/CMakeLists.txt ===
SET (libsolvext_SRCS
    solv_xfopen.c testcase.c)

SET (libsolvext_HEADERS
    tools_util.h solv_xfopen.h testcase.h)

IF (ENABLE_RPMDB)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
        pool_fileconflicts.c repo_rpmdb.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
        pool_fileconflicts.h repo_rpmdb.h)
ENDIF (ENABLE_RPMDB)

IF (ENABLE_PUBKEY)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	repo_pubkey.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	repo_pubkey.h)
ENDIF (ENABLE_PUBKEY)

IF (ENABLE_PGPVRFY)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	solv_pgpvrfy.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	solv_pgpvrfy.h)
ENDIF (ENABLE_PGPVRFY)

IF (ENABLE_RPMMD)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	repo_repomdxml.c repo_rpmmd.c
	repo_deltainfoxml.c repo_updateinfoxml.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	repo_repomdxml.h repo_rpmmd.h
	repo_deltainfoxml.h repo_updateinfoxml.h)
ENDIF (ENABLE_RPMMD)

IF (ENABLE_SUSEREPO)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	repo_content.c repo_products.c repo_releasefile_products.c
	repo_susetags.c repo_zyppdb.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	repo_content.h repo_products.h repo_releasefile_products.h
	repo_susetags.h repo_zyppdb.h)
ENDIF (ENABLE_SUSEREPO)

# old cmake does not support parenthetical expressions...
IF (ENABLE_COMPLEX_DEPS)
IF (ENABLE_SUSEREPO OR ENABLE_RPMMD OR ENABLE_RPMDB)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	pool_parserpmrichdep.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	pool_parserpmrichdep.h)
ENDIF (ENABLE_SUSEREPO OR ENABLE_RPMMD OR ENABLE_RPMDB)
ENDIF (ENABLE_COMPLEX_DEPS)

IF (SUSE)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	repo_autopattern.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	repo_autopattern.h)
ENDIF (SUSE)

IF (ENABLE_COMPS)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	repo_comps.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	repo_comps.h)
ENDIF (ENABLE_COMPS)

IF (ENABLE_DEBIAN)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	repo_deb.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	repo_deb.h)
ENDIF (ENABLE_DEBIAN)

IF (ENABLE_HELIXREPO)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	repo_helix.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	repo_helix.h)
ENDIF (ENABLE_HELIXREPO)

IF (ENABLE_MDKREPO)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	repo_mdk.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	repo_mdk.h)
ENDIF (ENABLE_MDKREPO)

IF (ENABLE_ARCHREPO)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	repo_arch.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	repo_arch.h)
ENDIF (ENABLE_ARCHREPO)

IF (ENABLE_CUDFREPO)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	repo_cudf.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	repo_cudf.h)
ENDIF (ENABLE_CUDFREPO)

IF (ENABLE_HAIKU)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	repo_haiku.cpp)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	repo_haiku.h)
ENDIF (ENABLE_HAIKU)

IF (ENABLE_APPDATA)
    SET (libsolvext_SRCS ${libsolvext_SRCS}
	repo_appdata.c)
    SET (libsolvext_HEADERS ${libsolvext_HEADERS}
	repo_appdata.h)
ENDIF (ENABLE_APPDATA)

SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
IF (HAVE_LINKER_VERSION_SCRIPT)
SET (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${LINK_FLAGS} -Wl,--version-script=${CMAKE_SOURCE_DIR}/ext/libsolvext.ver")
ENDIF (HAVE_LINKER_VERSION_SCRIPT)

IF (DISABLE_SHARED)
ADD_LIBRARY (libsolvext STATIC ${libsolvext_SRCS})
ELSE (DISABLE_SHARED)
ADD_LIBRARY (libsolvext SHARED ${libsolvext_SRCS})
TARGET_LINK_LIBRARIES(libsolvext libsolv ${SYSTEM_LIBRARIES})
ENDIF (DISABLE_SHARED)

SET_TARGET_PROPERTIES(libsolvext PROPERTIES OUTPUT_NAME "solvext")
SET_TARGET_PROPERTIES(libsolvext PROPERTIES SOVERSION ${LIBSOLVEXT_SOVERSION})
SET_TARGET_PROPERTIES(libsolvext PROPERTIES INSTALL_NAME_DIR ${LIB_INSTALL_DIR})

INSTALL (FILES ${libsolvext_HEADERS} DESTINATION "${INCLUDE_INSTALL_DIR}/solv")
INSTALL (TARGETS libsolvext LIBRARY DESTINATION ${LIB_INSTALL_DIR} ARCHIVE DESTINATION ${LIB_INSTALL_DIR})

IF (ENABLE_STATIC AND NOT DISABLE_SHARED)
ADD_LIBRARY (libsolvext_static STATIC ${libsolvext_SRCS})
SET_TARGET_PROPERTIES(libsolvext_static PROPERTIES OUTPUT_NAME "solvext")
SET_TARGET_PROPERTIES(libsolvext_static PROPERTIES SOVERSION ${LIBSOLVEXT_SOVERSION})
INSTALL (TARGETS libsolvext_static LIBRARY DESTINATION ${LIB_INSTALL_DIR} ARCHIVE DESTINATION ${LIB_INSTALL_DIR})
ENDIF (ENABLE_STATIC AND NOT DISABLE_SHARED)

=== debian/changelog ===
libsolv (0.6.21-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards: to 3.9.8. No changes needed.
    + Use https URLs in Vcs-*: fields.
    + Versioned D on dpkg-dev (>= 1.16.1.1).
    + Don't build dbg:packages anymore. See
      https://wiki.debian.org/AutomaticDebugPackages.
  * debian/{control,compat}:
    + Bump DH compat level to version 9.
  * debian/rules:
    + Create orig tarball in ../ rather than ./.
    + Enable all hardening build flags.
    + Use NEWS file as upstream changelog.
  * debian/patches:
    + Updates all patches.
    + Drop 1006_man-page-spelling-errors.patch. Applied upstream.
    + Add 1006_various-types.patch. Fix various typos and grammar
      issues.
  * debian/libsolv0-dev.install:
    + Upstream now provides a pkg-config .pc file.
  * debian/libsolv-tools.examples:
    + solv.c moved to examples/solv/ in source tree.
  * debian/libsolv-tools.examples:
    + solv.c moved to examples/solv/ in source tree.
  * debian/libsolv0.symbols:
    + Update symbols.
  * debian/copyright.in:
    + Update automatically generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 02 Jun 2016 17:38:33 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

PKD   = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
PKG   = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
UVER  = $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s+(?:\d+:)?(\d.*)(?:\-\d+.*)};')
DTYPE =
VER  ?= $(subst $(DTYPE),,$(UVER))

NULL =

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/class/python-module.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_DH_INSTALL_ARGS += --fail-missing

DEB_DH_INSTALLCHANGELOGS_ARGS = NEWS

DEB_INSTALL_DOCS_ALL = README CREDITS BUGS

DEB_CMAKE_EXTRA_FLAGS := \
                         -DCMAKE_INSTALL_PREFIX=/usr \
                         -DLIB="lib/$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)" \
                         -DINCLUDE="include/$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)" \
                         -DUSE_VENDORDIRS=1 \
                         -DMULTI_SEMANTICS=1 \
                         -DDEBIAN=1 \
                         -DENABLE_PUBKEY=1 \
                         -DENABLE_SUSEREPO=1 \
                         -DENABLE_RPMMD=1 \
                         -DENABLE_RPMDB=1 \
                         -DENABLE_RPMDB_BYRPMHEADER=1 \
                         -DENABLE_HELIXREPO=1 \
                         -DENABLE_DEBIAN=1 \
                         -DENABLE_MDKREPO=1 \
                         -DENABLE_ARCHREPO=1 \
                         -DENABLE_CUDFREPO=1 \
                         -DCMAKE_VERBOSE_MAKEFILE=ON \
                         -DENABLE_LZMA_COMPRESSION=1 \
                         -DENABLE_BZIP2_COMPRESSION=1 \
                         -DENABLE_PERL=1 \
                         -DENABLE_PYTHON=1 \
                         -DCMAKE_SKIP_RPATH=FALSE \
                         -DCMAKE_SKIP_INSTALL_RPATH=TRUE \
                         $(NULL)

DEB_MAKE_CHECK_TARGET := test

common-install-indep:: remove-cruft tweak-install
common-install-arch:: remove-cruft tweak-install

remove-cruft::
	@echo "Nothing to decruft after installation."

tweak-install::
	if [ -e debian/tmp/usr/bin/repo2solv.sh ]; then mv debian/tmp/usr/bin/repo2solv.sh debian/tmp/usr/bin/repo2solv; fi

get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz:
	@echo "# Downloading..."
	uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER) $(PKD)
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Extracting..."
	mkdir $(PKG)-$(VER) \
	    && tar -xf $(PKG)_$(VER).orig.tar.* --directory $(PKG)-$(VER) --strip-components 1 \
	    || $(RM) -r $(PKG)-$(VER)
#       @echo "# Cleaning-up..."
#       cd $(PKG)-$(VER) \
#           && find . -depth -type d -name 'windows' -exec $(RM) -r {} \; -printf 'removed %p\n' \
#           && $(RM) -r -v \
#               docs/
	$(RM) -v $(PKG)_$(VER).orig.tar.*
	@echo "# Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	    | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	    && $(RM) -r "$(PKG)-$(VER)"

## libsolv 0.6.24

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
 OPTION (USE_VENDORDIRS "Install the bindings in vendor directories?" OFF)
 
 OPTION (ENABLE_RPMDB "Build with rpm database support?" OFF)
+OPTION (ENABLE_RPMPKG "Build with rpm package support?" OFF)
 OPTION (ENABLE_PUBKEY "Build with pubkey support?" OFF)
 OPTION (ENABLE_RPMDB_BYRPMHEADER "Build with rpmdb Header support?" OFF)
 OPTION (ENABLE_RPMMD "Build with rpmmd repository support?" OFF)
@@ -172,8 +173,11 @@
 
 IF (MULTI_SEMANTICS)
 MESSAGE (STATUS "Enabling multi dist support")
-ADD_DEFINITIONS (-DMULTI_SEMANTICS)
 ENDIF (MULTI_SEMANTICS)
+
+IF (ENABLE_RPMDB)
+SET (ENABLE_RPMPKG ON)
+ENDIF (ENABLE_RPMDB)
 
 INCLUDE (CheckIncludeFile)
 IF (ENABLE_RPMDB)
@@ -237,14 +241,33 @@
 
 # should create config.h with #cmakedefine instead...
 FOREACH (VAR HAVE_STRCHRNUL HAVE_FOPENCOOKIE HAVE_FUNOPEN WORDS_BIGENDIAN
-  HAVE_RPM_DB_H HAVE_PGPDIGGETPARAMS
-  ENABLE_RPMDB ENABLE_PUBKEY ENABLE_RPMMD ENABLE_RPMDB_BYRPMHEADER ENABLE_SUSEREPO ENABLE_COMPS
-  ENABLE_HELIXREPO ENABLE_MDKREPO ENABLE_ARCHREPO ENABLE_DEBIAN ENABLE_HAIKU
-  ENABLE_LZMA_COMPRESSION ENABLE_BZIP2_COMPRESSION ENABLE_PGPVRFY ENABLE_APPDATA
-  ENABLE_LINKED_PKGS ENABLE_COMPLEX_DEPS)
+  HAVE_RPM_DB_H HAVE_PGPDIGGETPARAMS)
   IF(${VAR})
     ADD_DEFINITIONS (-D${VAR}=1)
     SET (SWIG_FLAGS ${SWIG_FLAGS} -D${VAR})
+  ENDIF (${VAR})
+ENDFOREACH (VAR)
+
+FOREACH (VAR
+  ENABLE_LINKED_PKGS ENABLE_COMPLEX_DEPS MULTI_SEMANTICS)
+  IF(${VAR})
+    ADD_DEFINITIONS (-D${VAR}=1)
+    SET (SWIG_FLAGS ${SWIG_FLAGS} -D${VAR})
+    STRING(REPLACE ENABLE_ "" VARX ${VAR})
+    SET (LIBSOLV_FEATURE_${VARX} 1)
+  ENDIF (${VAR})
+ENDFOREACH (VAR)
+
+FOREACH (VAR
+  ENABLE_RPMDB ENABLE_RPMPKG ENABLE_PUBKEY ENABLE_RPMMD ENABLE_RPMDB_BYRPMHEADER
+  ENABLE_SUSEREPO ENABLE_COMPS
+  ENABLE_HELIXREPO ENABLE_MDKREPO ENABLE_ARCHREPO ENABLE_DEBIAN ENABLE_HAIKU
+  ENABLE_LZMA_COMPRESSION ENABLE_BZIP2_COMPRESSION ENABLE_PGPVRFY ENABLE_APPDATA)
+  IF(${VAR})
+    ADD_DEFINITIONS (-D${VAR}=1)
+    SET (SWIG_FLAGS ${SWIG_FLAGS} -D${VAR})
+    STRING(REPLACE ENABLE_ "" VARX ${VAR})
+    SET (LIBSOLVEXT_FEATURE_${VARX} 1)
   ENDIF (${VAR})
 ENDFOREACH (VAR)
 
@@ -343,17 +366,3 @@
 ADD_SUBDIRECTORY (src)
 ADD_SUBDIRECTORY (ext)
 ADD_SUBDIRECTORY (tools)
-IF (ENABLE_PERL OR ENABLE_PYTHON OR ENABLE_RUBY OR ENABLE_TCL)
-    ADD_SUBDIRECTORY (bindings)
-ENDIF (ENABLE_PERL OR ENABLE_PYTHON OR ENABLE_RUBY OR ENABLE_TCL)
-ADD_SUBDIRECTORY (examples)
-ADD_SUBDIRECTORY (doc)
-
-MESSAGE (STATUS "Version: ${VERSION}")
-
-####################################################################
-# RPM SPEC                                                         #
-####################################################################
-
-MACRO (SPECFILE)
-  MESSAGE (STATUS "Writing spec file...")

=== src/CMakeLists.txt ===

INCLUDE (CheckFunctionExists)
CHECK_FUNCTION_EXISTS (qsort_r HAVE_QSORT_R)
CHECK_FUNCTION_EXISTS (__qsort_r HAVE___QSORT_R)

IF (HAVE_QSORT_R)
  ADD_DEFINITIONS (-DHAVE_QSORT_R=1)
ENDIF (HAVE_QSORT_R)

IF (HAVE___QSORT_R)
  ADD_DEFINITIONS (-DHAVE___QSORT_R=1)
ENDIF (HAVE___QSORT_R)

ADD_DEFINITIONS (-DLIBSOLV_INTERNAL=1)

SET (libsolv_SRCS
    bitmap.c poolarch.c poolvendor.c poolid.c strpool.c dirpool.c
    solver.c solverdebug.c repo_solv.c repo_write.c evr.c pool.c
    queue.c repo.c repodata.c repopage.c util.c policy.c solvable.c
    transaction.c order.c rules.c problems.c linkedpkg.c cplxdeps.c
    chksum.c md5.c sha1.c sha2.c solvversion.c selection.c
    fileprovides.c diskusage.c suse.c)

SET (libsolv_HEADERS
    bitmap.h evr.h hash.h policy.h poolarch.h poolvendor.h pool.h
    poolid.h pooltypes.h queue.h solvable.h solver.h solverdebug.h
    repo.h repodata.h repo_solv.h repo_write.h util.h selection.h
    strpool.h dirpool.h knownid.h transaction.h rules.h problems.h
    chksum.h dataiterator.h ${CMAKE_BINARY_DIR}/src/solvversion.h)

SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
IF (HAVE_LINKER_VERSION_SCRIPT)
SET (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${LINK_FLAGS} -Wl,--version-script=${CMAKE_SOURCE_DIR}/src/libsolv.ver")
ENDIF (HAVE_LINKER_VERSION_SCRIPT)

IF (DISABLE_SHARED)
ADD_LIBRARY (libsolv STATIC ${libsolv_SRCS})
ELSE (DISABLE_SHARED)
ADD_LIBRARY (libsolv SHARED ${libsolv_SRCS})
ENDIF (DISABLE_SHARED)

SET_TARGET_PROPERTIES(libsolv PROPERTIES OUTPUT_NAME "solv")
SET_TARGET_PROPERTIES(libsolv PROPERTIES SOVERSION ${LIBSOLV_SOVERSION})
SET_TARGET_PROPERTIES(libsolv PROPERTIES INSTALL_NAME_DIR ${LIB_INSTALL_DIR})

INSTALL (FILES ${libsolv_HEADERS} DESTINATION "${INCLUDE_INSTALL_DIR}/solv")
INSTALL (TARGETS libsolv LIBRARY DESTINATION ${LIB_INSTALL_DIR} ARCHIVE DESTINATION ${LIB_INSTALL_DIR})

IF (ENABLE_STATIC AND NOT DISABLE_SHARED)
ADD_LIBRARY (libsolv_static STATIC ${libsolv_SRCS})
SET_TARGET_PROPERTIES(libsolv_static PROPERTIES OUTPUT_NAME "solv")
SET_TARGET_PROPERTIES(libsolv_static PROPERTIES SOVERSION ${LIBSOLV_SOVERSION})
INSTALL (TARGETS libsolv_static LIBRARY DESTINATION ${LIB_INSTALL_DIR} ARCHIVE DESTINATION ${LIB_INSTALL_DIR})
ENDIF (ENABLE_STATIC AND NOT DISABLE_SHARED)

=== debian/changelog ===
libsolv (0.6.24-1+deb9u2) stretch; urgency=medium

  * debian/patches:
    + CVE-2019-20387: Add 0001_CVE-2019-20387.patch. Resolves heap-based
      buffer over-read in repodata.c (Closes: #949611).
    + Trivial rebase of patches 1004, 1006 and 2001.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 30 Jan 2020 18:49:35 +0100

libsolv (0.6.24-1+deb9u1) stretch; urgency=medium

  * debian/control:
    + Fix typo in D (python3-solv): Change ${python:Depends} to
      ${python3:Depends}. Spotted by Adrian Bunk. (Closes: #867407).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 18 Sep 2017 17:33:32 +0200

libsolv (0.6.24-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 1002_support-python2+3-bindings-simultaneously.patch.
      Resolved (differently) upstream.
    + Drop 1005_provide-repo-autopattern-for-non-SUSE-builds.patch.
      Solved upstream.
  * debian/rules:
    + Set ENABLE_PYTHON3 to 1 for enabling python3 bindings build for libsolv.
  * debian/{libsolv0,libsolvext0}.symbols:
    + Update symbols for 0.6.24 upstream release.
  * debian/copyright
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 10 Jan 2017 19:54:45 +0100

=== debian/control ===
Source: libsolv
Section: admin
Priority: extra
Maintainer: Mike Gabriel <sunweaver@debian.org> 
Build-Depends:
 debhelper (>= 9),
 dpkg-dev (>= 1.16.1.1),
 cdbs,
 cmake, 
 libexpat1-dev,
 zlib1g-dev,
 librpm-dev (>= 4),
 liblzma-dev,
 libbz2-dev,
 python-dev,
 libpython-dev,
 python3-dev,
 libpython3-dev,
 swig,
Standards-Version: 3.9.8
Homepage: https://github.com/openSUSE/libsolv
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/libsolv.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/libsolv.git
X-Python-Version: >=2.6
X-Python3-Version: >=3.2

Package: libsolv0
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: dependency solver using a satisfiability algorithm (shared library)
 This dependency solver code in this package is based on two major, but
 independent, blocks:
 .
 1. Using a dictionary approach to store and retrieve package
    and dependency information.
 2. Using satisfiability, a well known and researched topic, for
    resolving package dependencies.
 .
 Supported package formats:
   - rpm/rpm5
   - deb
   - Arch Linux
   - haiku
 .
 Supported repository formats:
   - rpmmd (primary, filelists, comps, deltainfo/presto, updateinfo)
   - susetags, suse product formats
   - mandriva/mageia (synthesis, info, files)
   - Arch Linux
   - red carpet helix format
   - haiku

Package: libsolv-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends}
Description: dependency solver using a satisfiablility algorithm (documentation files)
 This dependency solver code in this package is based on two major, but
 independent, blocks:
 .
 1. Using a dictionary approach to store and retrieve package
    and dependency information.
 2. Using satisfiability, a well known and researched topic, for
    resolving package dependencies.
 .
 This package contains documentation files for libsolv.

Package: libsolv0-dev
Section: libdevel
Architecture: any 
Multi-Arch: same
Provides:
 libsolv-dev
Depends:
 ${misc:Depends},
 libsolv0 (= ${binary:Version}),
 libsolvext0-dev (= ${binary:Version}),
Description: dependency solver using a satisfiability algorithm (development files)
 This dependency solver code in this package is based on two major, but
 independent, blocks:
 .
 1. Using a dictionary approach to store and retrieve package
    and dependency information.
 2. Using satisfiability, a well known and researched topic, for
    resolving package dependencies.
 .
 This package contains development files for libsolv.

Package: libsolvext0
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: dependency solver using a satisfiability algorithm (extensions)
 This dependency solver code in this package is based on two major, but
 independent, blocks:
 .
 1. Using a dictionary approach to store and retrieve package
    and dependency information.
 2. Using satisfiability, a well known and researched topic, for
    resolving package dependencies.
 .
 Search the internet  for 'sat solver' to get links to the theory behind it.
 .
 Supported package formats:
   - rpm/rpm5
   - deb
   - Arch Linux
   - haiku
 .
 Supported repository formats:
   - rpmmd (primary, filelists, comps, deltainfo/presto, updateinfo)
   - susetags, suse product formats
   - mandriva/mageia (synthesis, info, files)
   - Arch Linux
   - red carpet helix format
   - haiku
 .
 This package contains the libsolv extension library.

Package: libsolvext0-dev
Section: libdevel
Architecture: any 
Multi-Arch: same
Provides:
 libsolvext-dev
Depends:
 ${misc:Depends},
 libsolvext0 (= ${binary:Version}),
Description: dependency solver using a satisfiability algorithm (ext development files)
 This dependency solver code in this package is based on two major, but
 independent, blocks:
 .
 1. Using a dictionary approach to store and retrieve package
    and dependency information.
 2. Using satisfiability, a well known and researched topic, for
    resolving package dependencies.
 .
 This package contains development files for libsolvext.

Package: libsolv-tools
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libsolv0 (= ${binary:Version}),
Description: dependency solver using a satisfiability algorithm (command-line tools)
 This dependency solver code in this package is based on two major, but
 independent, blocks:
 .
 1. Using a dictionary approach to store and retrieve package
    and dependency information.
 2. Using satisfiability, a well known and researched topic, for
    resolving package dependencies.
 .
 This package contains command-line tools that facilitate using libsolv.

Package: python-solv
Section: python
Architecture: any
Depends:
 ${python:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 libsolv0 (= ${binary:Version}),
Description: dependency solver using a satisfiability algorithm (Python2 bindings)
 This dependency solver code in this package is based on two major, but
 independent, blocks:
 .
 1. Using a dictionary approach to store and retrieve package
    and dependency information.
 2. Using satisfiability, a well known and researched topic, for
    resolving package dependencies.
 .
 This package contains the Python (v2) bindings for the libsolv0 library.

Package: python3-solv
Section: python
Architecture: any
Depends:
 ${python3:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 libsolv0 (= ${binary:Version}),
Description: dependency solver using a satisfiability algorithm (Python3 bindings)
 This dependency solver code in this package is based on two major, but
 independent, blocks:
 .
 1. Using a dictionary approach to store and retrieve package
    and dependency information.
 2. Using satisfiability, a well known and researched topic, for
    resolving package dependencies.
 .
 This package contains the Python (v3) bindings for the libsolv0 library.

Package: libsolv-perl
Section: perl
Architecture: any
Depends:
 ${perl:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 libsolv0 (= ${binary:Version}),
Description: dependency solver using a satisfiability algorithm (Perl bindings)
 This dependency solver code in this package is based on two major, but
 independent, blocks:
 .
 1. Using a dictionary approach to store and retrieve package
    and dependency information.
 2. Using satisfiability, a well known and researched topic, for
    resolving package dependencies.
 .
 This package contains the Perl bindings for the libsolv0 library.

=== debian/rules ===
--- 
+++ 
@@ -54,6 +54,7 @@
                          -DENABLE_BZIP2_COMPRESSION=1 \
                          -DENABLE_PERL=1 \
                          -DENABLE_PYTHON=1 \
+                         -DENABLE_PYTHON3=1 \
                          -DCMAKE_SKIP_RPATH=FALSE \
                          -DCMAKE_SKIP_INSTALL_RPATH=TRUE \
                          $(NULL)

## libsolv 0.6.28

=== debian/changelog ===
libsolv (0.6.28-2build1) artful; urgency=medium

  * No-change rebuild for perl 5.26.0.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 26 Jul 2017 19:53:04 +0000

libsolv (0.6.28-2) unstable; urgency=medium

  [ gregor herrmann ]
  * Fix "python2.7/cmake: find_package called with invalid argument
    "2.7.13+"":
    Add 1008_cmake-python-version.patch to sanitize PYTHONLIBS_VERSION_STRING
    before passing it to 'FIND_PACKAGE (PythonInterp)'.
    (Closes: #867514)

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 24 Jul 2017 10:10:08 +0200

libsolv (0.6.28-1) unstable; urgency=medium

  * New upstream release. (Closes: #865033).
  * debian/libsolv0.symbols:
    + Update symbols file.
  * debian/control:
    + Fix typo in D (python3-pampy): Change ${python:Depends} to
      ${python3:Depends}. Spotted by Adrian Bunk. (Closes: #867407).
    + Bump Standards-Version: to 4.0.0. No changes needed.
  * debian/copyright:
    + Update copyright attributions.
  * debian/libsolvext0-dev.install:
    + Add usr/lib/*/pkgconfig/libsolvext.pc to list of files to install
      into libsolvext0-dev.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 06 Jul 2017 22:11:26 +0200

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
  python3-dev,
  libpython3-dev,
  swig,
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://github.com/openSUSE/libsolv
 Vcs-Browser: https://anonscm.debian.org/git/collab-maint/libsolv.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/libsolv.git

## libsolv 0.6.30

=== CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,8 @@
 
 OPTION (ENABLE_LZMA_COMPRESSION "Build with lzma/xz compression support?" OFF)
 OPTION (ENABLE_BZIP2_COMPRESSION "Build with bzip2 compression support?" OFF)
+
+OPTION (WITH_LIBXML2  "Build with libxml2 instead of libexpat?" OFF)
 
 #IF(${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERISION} GREATER 2.4)
 #ENDIF(${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERISION} GREATER 2.4)
@@ -58,12 +60,17 @@
 ENDIF (DEFINED  INCLUDE)
 MESSAGE (STATUS "Header files will be installed in ${INCLUDE_INSTALL_DIR}")
 SET (BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin")
+IF (NOT MAN_INSTALL_DIR)
 SET (MAN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/man")
 IF (IS_DIRECTORY "${CMAKE_INSTALL_PREFIX}/man"  AND NOT IS_DIRECTORY "${CMAKE_INSTALL_PREFIX}/share/man")
   SET (MAN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/man")
 ENDIF (IS_DIRECTORY "${CMAKE_INSTALL_PREFIX}/man"  AND NOT IS_DIRECTORY "${CMAKE_INSTALL_PREFIX}/share/man")
+ENDIF (NOT MAN_INSTALL_DIR)
 MESSAGE(STATUS "Man pages will be installed in ${MAN_INSTALL_DIR}")
 
+IF (NOT PKGCONFIG_INSTALL_DIR)
+  SET (PKGCONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/pkgconfig)
+ENDIF (NOT PKGCONFIG_INSTALL_DIR)
 ####################################################################
 # CONFIGURATION                                                    #
 ####################################################################
@@ -148,15 +155,29 @@
     MESSAGE (FATAL_ERROR "Can only compile for one system type.")
 ENDIF (${have_system} STRGREATER xx)
 
-IF (ENABLE_ARCHREPO)
+SET (ENABLE_ZLIB_COMPRESSION ON)
+IF (ENABLE_ARCHREPO OR ENABLE_DEBIAN)
 SET (ENABLE_LZMA_COMPRESSION ON)
-ENDIF (ENABLE_ARCHREPO)
-
+ENDIF (ENABLE_ARCHREPO OR ENABLE_DEBIAN)
+
+IF (ENABLE_RPMMD OR ENABLE_SUSEREPO OR ENABLE_APPDATA OR ENABLE_COMPS OR ENABLE_HELIXREPO OR ENABLE_MDKREPO)
+IF (WITH_LIBXML2 )
+FIND_PACKAGE (LibXml2 REQUIRED)
+INCLUDE_DIRECTORIES (${LIBXML2_INCLUDE_DIR})
+ELSE(WITH_LIBXML2 )
 FIND_PACKAGE (EXPAT REQUIRED)
+INCLUDE_DIRECTORIES (${EXPAT_INCLUDE_DIRS})
+ENDIF (WITH_LIBXML2 )
+ENDIF (ENABLE_RPMMD OR ENABLE_SUSEREPO OR ENABLE_APPDATA OR ENABLE_COMPS OR ENABLE_HELIXREPO OR ENABLE_MDKREPO)
+
+IF (ENABLE_ZLIB_COMPRESSION)
 FIND_PACKAGE (ZLIB REQUIRED)
+ENDIF (ENABLE_ZLIB_COMPRESSION)
+
 IF (ENABLE_LZMA_COMPRESSION)
 FIND_PACKAGE (LZMA REQUIRED)
 ENDIF (ENABLE_LZMA_COMPRESSION)
+
 IF (ENABLE_BZIP2_COMPRESSION)
 FIND_PACKAGE (BZip2 REQUIRED)
 ENDIF (ENABLE_BZIP2_COMPRESSION)
@@ -206,6 +227,9 @@
     IF (DB_LIBRARY)
       SET (RPMDB_LIBRARY ${DB_LIBRARY} ${RPMDB_LIBRARY})
     ENDIF (DB_LIBRARY)
+    IF (DB_INCLUDE_DIR)
+      INCLUDE_DIRECTORIES (${DB_INCLUDE_DIR})
+    ENDIF (DB_INCLUDE_DIR)
   ENDIF (NOT HAVE_RPM_DB_H)
   INCLUDE (CheckLibraryExists)
   CHECK_LIBRARY_EXISTS(rpmio pgpDigGetParams "" HAVE_PGPDIGGETPARAMS)
@@ -241,7 +265,7 @@
 
 # should create config.h with #cmakedefine instead...
 FOREACH (VAR HAVE_STRCHRNUL HAVE_FOPENCOOKIE HAVE_FUNOPEN WORDS_BIGENDIAN
-  HAVE_RPM_DB_H HAVE_PGPDIGGETPARAMS)
+  HAVE_RPM_DB_H HAVE_PGPDIGGETPARAMS WITH_LIBXML2 )
   IF(${VAR})
     ADD_DEFINITIONS (-D${VAR}=1)
     SET (SWIG_FLAGS ${SWIG_FLAGS} -D${VAR})
@@ -260,9 +284,10 @@
 
 FOREACH (VAR
   ENABLE_RPMDB ENABLE_RPMPKG ENABLE_PUBKEY ENABLE_RPMMD ENABLE_RPMDB_BYRPMHEADER
-  ENABLE_SUSEREPO ENABLE_COMPS
+  ENABLE_SUSEREPO ENABLE_COMPS ENABLE_TESTCASE_HELIXREPO
   ENABLE_HELIXREPO ENABLE_MDKREPO ENABLE_ARCHREPO ENABLE_DEBIAN ENABLE_HAIKU
-  ENABLE_LZMA_COMPRESSION ENABLE_BZIP2_COMPRESSION ENABLE_PGPVRFY ENABLE_APPDATA)
+  ENABLE_ZLIB_COMPRESSION ENABLE_LZMA_COMPRESSION ENABLE_BZIP2_COMPRESSION
+  ENABLE_PGPVRFY ENABLE_APPDATA)
   IF(${VAR})
     ADD_DEFINITIONS (-D${VAR}=1)
     SET (SWIG_FLAGS ${SWIG_FLAGS} -D${VAR})
@@ -341,28 +366,3 @@
 
 MESSAGE (STATUS "Looking for modules in ${CMAKE_MODULE_PATH}")
 
-set (CMAKE_C_FLAGS     "${CMAKE_C_FLAGS} -Wall")
-set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS} -O3")
-set (CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS} -g -O3")
-set (CMAKE_C_FLAGS_DEBUG     "${CMAKE_C_FLAGS} -g3 -O0")
-
-SET (SYSTEM_LIBRARIES ${EXPAT_LIBRARY} ${ZLIB_LIBRARY})
-IF (ENABLE_LZMA_COMPRESSION)
-SET (SYSTEM_LIBRARIES ${SYSTEM_LIBRARIES} ${LZMA_LIBRARY})
-ENDIF (ENABLE_LZMA_COMPRESSION)
-IF (ENABLE_BZIP2_COMPRESSION)
-SET (SYSTEM_LIBRARIES ${SYSTEM_LIBRARIES} ${BZIP2_LIBRARIES})
-ENDIF (ENABLE_BZIP2_COMPRESSION)
-IF (ENABLE_RPMDB)
-SET (SYSTEM_LIBRARIES ${RPMDB_LIBRARY} ${SYSTEM_LIBRARIES})
-ENDIF (ENABLE_RPMDB)
-IF (ENABLE_HAIKU)
-SET (SYSTEM_LIBRARIES ${HAIKU_SYSTEM_LIBRARIES} ${SYSTEM_LIBRARIES})
-ENDIF (ENABLE_HAIKU)
-IF (HAVE_LINKER_AS_NEEDED)
-SET (SYSTEM_LIBRARIES "-Wl,--as-needed" ${SYSTEM_LIBRARIES})
-ENDIF (HAVE_LINKER_AS_NEEDED)
-
-ADD_SUBDIRECTORY (src)
-ADD_SUBDIRECTORY (ext)
-ADD_SUBDIRECTORY (tools)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
     queue.c repo.c repodata.c repopage.c util.c policy.c solvable.c
     transaction.c order.c rules.c problems.c linkedpkg.c cplxdeps.c
     chksum.c md5.c sha1.c sha2.c solvversion.c selection.c
-    fileprovides.c diskusage.c suse.c)
+    fileprovides.c diskusage.c suse.c solver_util.c cleandeps.c)
 
 SET (libsolv_HEADERS
     bitmap.h evr.h hash.h policy.h poolarch.h poolvendor.h pool.h
@@ -44,7 +44,7 @@
 SET_TARGET_PROPERTIES(libsolv PROPERTIES INSTALL_NAME_DIR ${LIB_INSTALL_DIR})
 
 INSTALL (FILES ${libsolv_HEADERS} DESTINATION "${INCLUDE_INSTALL_DIR}/solv")
-INSTALL (TARGETS libsolv LIBRARY DESTINATION ${LIB_INSTALL_DIR} ARCHIVE DESTINATION ${LIB_INSTALL_DIR})
+INSTALL (TARGETS libsolv LIBRARY DESTINATION ${LIB_INSTALL_DIR} ARCHIVE DESTINATION ${LIB_INSTALL_DIR} RUNTIME DESTINATION bin)
 
 IF (ENABLE_STATIC AND NOT DISABLE_SHARED)
 ADD_LIBRARY (libsolv_static STATIC ${libsolv_SRCS})

=== debian/changelog ===
libsolv (0.6.30-1build1) bionic; urgency=medium

  * No-change rebuild for librpm soname bump.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 12 Nov 2017 15:17:22 +0100

libsolv (0.6.30-1) unstable; urgency=medium

  [ Héctor Orón Martínez ]
  * New upstream release.
  * debian/control: bump standards version
    + switch priority extra to optional
  * debian/control: move libsolv0 and libsolvext0 to section libs
  * debian/libsolv0.symbols: update

  [ Mike Gabriel ]
  * debian/patches:
    + Drop 0001_get-rid-of-path-max.patch as a file. The series file already had
      this patched removed by Héctor Orón Martínez.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 03 Nov 2017 09:02:08 +0100

libsolv (0.6.29-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 1008_cmake-python-version.patch. Applied upstream.
    + Rebase patches against recent upstream release.
    + Add 0001_get-rid-of-path-max.patch. Fix FTBFS on Debian GNU/Hurd where
      PATH_MAX is not defined.
  * debian/rules:
    + Use tarball from upstream URL as is. Don't repack it anymore.
  * debian/copyright:
    + Update auto-generated copyright.in.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 18 Sep 2017 17:16:24 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: libsolv
 Section: admin
-Priority: extra
+Priority: optional
 Maintainer: Mike Gabriel <sunweaver@debian.org> 
 Build-Depends:
  debhelper (>= 9),
@@ -17,7 +17,7 @@
  python3-dev,
  libpython3-dev,
  swig,
-Standards-Version: 4.0.0
+Standards-Version: 4.1.1
 Homepage: https://github.com/openSUSE/libsolv
 Vcs-Browser: https://anonscm.debian.org/git/collab-maint/libsolv.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/libsolv.git
@@ -25,6 +25,7 @@
 X-Python3-Version: >=3.2
 
 Package: libsolv0
+Section: libs
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -91,6 +92,7 @@
  This package contains development files for libsolv.
 
 Package: libsolvext0
+Section: libs
 Architecture: any
 Multi-Arch: same
 Depends:

=== debian/rules ===
--- 
+++ 
@@ -8,12 +8,6 @@
 
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
-
-PKD   = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
-PKG   = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
-UVER  = $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s+(?:\d+:)?(\d.*)(?:\-\d+.*)};')
-DTYPE =
-VER  ?= $(subst $(DTYPE),,$(UVER))
 
 NULL =
 
@@ -70,24 +64,5 @@
 tweak-install::
 	if [ -e debian/tmp/usr/bin/repo2solv.sh ]; then mv debian/tmp/usr/bin/repo2solv.sh debian/tmp/usr/bin/repo2solv; fi
 
-get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
-	@
-
-$(PKG)_$(VER)$(DTYPE).orig.tar.xz:
-	@echo "# Downloading..."
-	uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER) $(PKD)
-	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
-	@echo "# Extracting..."
-	mkdir $(PKG)-$(VER) \
-	    && tar -xf $(PKG)_$(VER).orig.tar.* --directory $(PKG)-$(VER) --strip-components 1 \
-	    || $(RM) -r $(PKG)-$(VER)
-#       @echo "# Cleaning-up..."
-#       cd $(PKG)-$(VER) \
-#           && find . -depth -type d -name 'windows' -exec $(RM) -r {} \; -printf 'removed %p\n' \
-#           && $(RM) -r -v \
-#               docs/
-	$(RM) -v $(PKG)_$(VER).orig.tar.*
-	@echo "# Packing..."
-	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
-	    | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
-	    && $(RM) -r "$(PKG)-$(VER)"
+get-orig-source:
+	uscan --noconf --force-download --rename --download-current-version --destdir=..
